#!/bin/sh

vialver=xwhatsit-0p9p0
nathanaver=null

# -- CHANGE THESE SETTINGS PER KEYBOARD --
model=ibm_f107
keymap=xwhatsit_blankeeprom
# ----------------------------------------

echo
echo Preparing to flash firmware for \""$model"\" with keymap \""$keymap"\"...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 get bootloader-version > /dev/null 2>&1
if [ $? -gt 0 ]; then
echo
echo Please plug in keyboard to be flashed, and put into bootloader/flash mode.
echo Waiting for keyboard...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 get bootloader-version > /dev/null 2>&1
while [ $? -gt 0 ]; do
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 get bootloader-version > /dev/null 2>&1
done
fi
echo
echo \* Wiping existing flash memory and EEPROM...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 erase --force > /dev/null 2>&1
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 flash --force --suppress-validation --eeprom "$(dirname "$0")"/bin/reset.eep > /dev/null 2>&1
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 flash --force "$(dirname "$0")"/bin/eeprom_eraser.hex > /dev/null 2>&1
echo \* Resetting controller for main flash...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 reset > /dev/null 2>&1
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 get bootloader-version > /dev/null 2>&1
while [ $? -gt 0 ]; do
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 get bootloader-version > /dev/null 2>&1
done
echo \* Flashing \""$model"\" firmware...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 erase --force > /dev/null 2>&1
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 flash --force "$(dirname "$0")"/firmwares/new"$model"-"$vialver"_"$nathanaver".hex > /dev/null 2>&1
echo \* Flashing \""$keymap"\" keymap...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 flash --force --eeprom "$(dirname "$0")"/keymaps/"$model"/"$model"-"$keymap".hex > /dev/null 2>&1
echo \* Rebooting keyboard controller...
"$(dirname "$0")"/bin/dfu-programmer atmega32u2 reset > /dev/null 2>&1
echo
echo ...done!
echo
read -p "Press any key to continue . . . "
echo
